require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_TRACEPOINT_H)) {
    eval 'sub _LINUX_TRACEPOINT_H () {1;}' unless defined(&_LINUX_TRACEPOINT_H);
    require 'linux/types.ph';
    require 'linux/rcupdate.ph';
    eval 'sub TPPROTO () {( &args...)  &args;}' unless defined(&TPPROTO);
    eval 'sub TPARGS () {( &args...)  &args;}' unless defined(&TPARGS);
    if(defined(&CONFIG_TRACEPOINTS)) {
	eval 'sub __DO_TRACE {
	    my($tp, $proto, $args) = @_;
    	    eval q( &do {  &void ** &it_func;  &rcu_read_lock_sched();  &it_func =  &rcu_dereference(($tp)-> &funcs);  &if ( &it_func) {  &do { (( &void(*)($proto))(* &it_func))($args); }  &while (*(++ &it_func)); }  &rcu_read_unlock_sched(); }  &while (0));
	}' unless defined(&__DO_TRACE);
	eval 'sub DEFINE_TRACE_WITH_CALLBACK {
	    my($name, $proto, $args, $reg, $unreg) = @_;
    	    eval q( &static  &inline  &void  &trace_$name($proto) {  &static  &const \'char\'  &__tpstrtab_$name->[]  &__attribute__(( &section(\\"__tracepoints_strings\\"))) = $name;  &static \'struct tracepoint\'  &__tracepoint_$name  &__attribute__(( &section(\\"__tracepoints\\"),  &aligned(8))) = {  &__tpstrtab_$name, 0,  &NULL };  &if ( &unlikely( &__tracepoint_ ($name->{state})))  &__DO_TRACE(& &__tracepoint_$name,  &TPPROTO($proto),  &TPARGS($args)); }  &static  &inline \'int\'  &register_trace_$name( &void (* &probe)($proto)) { \'int\'  &ret;  &void (* &func)( &void) = $reg;  &ret =  &tracepoint_probe_register($name, ( &void *) &probe);  &if ( &func  && ! &ret)  &func();  &return  &ret; }  &static  &inline \'int\'  &unregister_trace_$name( &void (* &probe)($proto)) { \'int\'  &ret;  &void (* &func)( &void) = $unreg;  &ret =  &tracepoint_probe_unregister($name, ( &void *) &probe);  &if ( &func  && ! &ret)  &func();  &return  &ret; });
	}' unless defined(&DEFINE_TRACE_WITH_CALLBACK);
	eval 'sub DEFINE_TRACE {
	    my($name, $proto, $args) = @_;
    	    eval q( &DEFINE_TRACE_WITH_CALLBACK($name,  &TPPROTO($proto),  &TPARGS($args),  &NULL,  &NULL););
	}' unless defined(&DEFINE_TRACE);
    } else {
	eval 'sub DEFINE_TRACE_WITH_CALLBACK {
	    my($name, $proto, $args, $reg, $unreg) = @_;
    	    eval q( &static  &inline  &void  &_do_trace_$name(\'struct tracepoint\' * &tp, $proto) { }  &static  &inline  &void  &trace_$name($proto) { }  &static  &inline \'int\'  &register_trace_$name( &void (* &probe)($proto)) {  &return - &ENOSYS; }  &static  &inline \'int\'  &unregister_trace_$name( &void (* &probe)($proto)) {  &return - &ENOSYS; });
	}' unless defined(&DEFINE_TRACE_WITH_CALLBACK);
	eval 'sub DEFINE_TRACE {
	    my($name, $proto, $args) = @_;
    	    eval q( &DEFINE_TRACE_WITH_CALLBACK($name,  &TPPROTO($proto),  &TPARGS($args),  &NULL,  &NULL););
	}' unless defined(&DEFINE_TRACE);
	eval 'sub tracepoint_update_probe_range {
	    my($begin,$end) = @_;
    	    eval q({ });
	}' unless defined(&tracepoint_update_probe_range);
    }
}
1;
